package com.wd.workoffice.ui.activity.mes.ticket;

import android.Manifest;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bumptech.glide.load.model.GlideUrl;
import com.tbruyelle.rxpermissions2.RxPermissions;
import com.wd.workoffice.R;
import com.wd.workoffice.app.BaseMesBean;
import com.wd.workoffice.app.WorkToolBarActivity;
import com.wd.workoffice.bean.mesBean.TicketBean;
import com.wd.workoffice.retrofit.ApiService;
import com.wd.workoffice.retrofit.RtfUtils;
import com.wd.workoffice.retrofit.WorkObserver;
import com.wd.workoffice.ui.activity.bat.store.StoreSaleConfirmActivity;
import com.wd.workoffice.util.Glide4Engine;
import com.wd.workoffice.util.WorkUtils;
import com.zhihu.matisse.Matisse;
import com.zhihu.matisse.MimeType;
import com.zhihu.matisse.internal.entity.CaptureStrategy;

import java.io.File;
import java.util.Map;

import androidx.annotation.Nullable;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import flexible.xd.android_base.network.rtfhttp.RtfHelper;
import flexible.xd.android_base.network.rtfhttp.Transformer;
import io.reactivex.disposables.Disposable;
import okhttp3.MediaType;
import okhttp3.MultipartBody;
import okhttp3.RequestBody;

/**
 * 工单新增
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class MesTicketAddLogActivity extends WorkToolBarActivity {
    @BindView(R.id.tv_code)
    TextView tvCode;
    @BindView(R.id.tv_time)
    TextView tvTime;
    @BindView(R.id.tv_create_person)
    TextView tvCreatePerson;
    @BindView(R.id.et_content)
    EditText etContent;
    @BindView(R.id.et_question_desc)
    EditText etQuestionDesc;
    @BindView(R.id.et_client)
    EditText etClient;
    @BindView(R.id.iv_img1)
    ImageView ivImg1;
    @BindView(R.id.iv_img2)
    ImageView ivImg2;
    @BindView(R.id.iv_img3)
    ImageView ivImg3;
    private Map<String, Object> param;
    private TicketBean.ListBean data;

    @Override
    protected void initView() {
        ButterKnife.bind(this);
        data = JSON.parseObject(getIntent().getStringExtra("data"), TicketBean.ListBean.class);
        tvCode.setText(data.getJobNo());
        tvTime.setText(data.getCreateDateTime());
        tvCreatePerson.setText(data.getCreateUserName());
    }

    @Override
    protected void initData() {
        param = WorkUtils.simpleParam();
        param.put("jobNo", data.getJobNo());
    }

    private void submit() {
        RtfUtils.getMesRtf().logAdd("1", "1", WorkUtils.convertMapToBody(param)).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {


            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (!data.isSuccess()) {
                    toast(data.getMessage());
                    return;
                }
                finish();
                toast("添加成功");
            }
        });
    }

    @Override
    protected void initEvent() {
    }

    @Override
    protected int layoutId() {
        return R.layout.activity_mes_ticket_log_add;
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_report, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.report:
                String client = etClient.getText().toString();
                String content = etContent.getText().toString();
                String desc = etQuestionDesc.getText().toString();
                param.put("customerDemand", client);
                param.put("jobContent", content);
                param.put("problemDescription", desc);
//                param.put("attachments", Arrays.asList("https://image.baidu.com/search/redirect?tn=redirect&word=j&juid=60A17C&sign=ckwboawzac&url=http%3A%2F%2Fwww.he-nan.com%2Fwtx%2Fswaxd%2Fnew-126233.html&bakfurl1=http%3A%2F%2Fwww.jnhsgc.com%2Fwtx%2Fswaxd%2Fshow%2F2188241.html&bakfurl2=http%3A%2F%2Fwww.10huan.com%2Fwtx%2Fswaxd%2Fnew-1240701.html&objurl=https%3A%2F%2Ftimgsa.baidu.com%2Ftimg%3Fimage%26quality%3D80%26size%3Db9999_10000%26sec%3D1587918679912%26di%3D8f01c77314881dad317d1cbda58cd0bf%26imgtype%3D0%26src%3Dhttp%253A%252F%252Fimg.yzt-tools.com%252F20190218%252Fca736a78109decf300cbaf239cc32545.jpg"));
                submit();
                break;
        }
        return super.onOptionsItemSelected(item);
    }


    @OnClick({R.id.iv_img1, R.id.iv_img2, R.id.iv_img3})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.iv_img1:
                break;
            case R.id.iv_img2:
                break;
            case R.id.iv_img3:
                break;
        }
    }

    private void addImg(int position) {
        RxPermissions rxPermissions = new RxPermissions(this);
        rxPermissions
                .request(Manifest.permission.CAMERA,
                        Manifest.permission.READ_EXTERNAL_STORAGE,
                        Manifest.permission.WRITE_EXTERNAL_STORAGE)
                .subscribe(granted -> {
                    if (granted) {
                        // All requested permissions are granted
                        Matisse.from(MesTicketAddLogActivity.this)
                                .choose(MimeType.ofImage())
                                .countable(true)
                                .maxSelectable(1).capture(true).
                                captureStrategy(new CaptureStrategy(true, "com.wd.workoffice.fileprovider"))
//                                        .addFilter(new GifSizeFilter(320, 320, 5 * Filter.K * Filter.K))
//                                        .gridExpectedSize(getResources().getDimensionPixelSize(R.dimen.grid_expected_size))
                                .restrictOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED)
                                .thumbnailScale(0.85f)
                                .imageEngine(new Glide4Engine())
                                .forResult(10000 + position);
                    } else {
                        // At least one permission is denied
                        toast("您需要开启拍照、存储权限！");
                    }
                });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK) {
            switch (requestCode) {
                case 10001:
                    if (Matisse.obtainResult(data).size() != 0) {
                        upload(1, Matisse.obtainResult(data).get(0));
                    }
                    break;
                case 10002:
                    if (Matisse.obtainResult(data).size() != 0) {
                        upload(2, Matisse.obtainResult(data).get(0));
                    }
                    break;
                case 10003:
                    if (Matisse.obtainResult(data).size() != 0) {
                        upload(3, Matisse.obtainResult(data).get(0));
                    }
                    break;
            }
        }
    }

    private void upload(int position, Uri data) {
        showLoading();
        File file = WorkUtils.uriToFile(data, this);
        RequestBody requestFile = RequestBody.create(MediaType.parse("image/png"), file);
        RtfUtils.getMesRtf().
                upload(MultipartBody.Part.createFormData("file", file.getName(), requestFile)).
                compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {
            @Override
            public void doOnSubscribe(Disposable d) {

            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (data.isSuccess()) {
                    toast(data.getMessage());
                    return;
                }
                toast("上传成功");
            }
        });
    }
}
